#!/usr/local/bin/perl54

$DEBUG = 0;

require 'getopts.pl';

use Oraperl;

require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/username.pl';
require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/user_paths.pl';

#DO NOT require user_specs.pl in this package.  it will infinite loop

  print "<!-- 8/98 revision --><BR>\n";
  print "<!-- 11/8/97 revision --><BR>\n";


sub write_default_test
{
   local ($modelin) = @_;
   print "<P><HR><P>Input model to write_default_table is $modelin<BR>\n";
}


# ***************************************************
# Gets default fields and builds table
# ***************************************************
sub write_default_table
{
   local ($modelin, $unittype) = @_;

   local($GET_TABLE) = "SELECT datatablename, modelalias
                         FROM commercial_products
                        WHERE upper(model) = :1";  

   local($GET_DEFAULT_FIELDS_ENGLISH) = 
                 "SELECT fieldname, columncaption, fielddisplayname,
                         defaultfieldorder, englishunits
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND defaultfield=1
                     AND upper(tablename) = :1";
 
   local($GET_DEFAULT_FIELDS_METRIC) = 
                 "SELECT fieldname, columncaption, fielddisplayname,
                         defaultfieldorder, metricunits
                    FROM field_properties
                   WHERE (units=2 OR units=0) 
                     AND defaultfield=1
                     AND upper(tablename) = :1";
 
   $upper_unittype = $unittype;
   $upper_unittype =~ tr/a-z/A-Z/;

   print "<!-- writing in pkg_data_tables write_default_table -->\n";

   print "<!-- Input model to write_default_table is $modelin -->\n";

   $csra = &ora_open($lda, $GET_TABLE)        
                      || print "failed to open $GET_TABLE";

   if ($upper_unittype eq 'ENGLISH') {
       $csrb = &ora_open($lda, $GET_DEFAULT_FIELDS_ENGLISH)   
               || print "failed to open cursor $GET_DEFAULT_FIELDS_ENGLISH";
   }
   elsif ($upper_unittype eq 'METRIC') {
       $csrb = &ora_open($lda, $GET_DEFAULT_FIELDS_METRIC)
               || print "failed to open cursor $GET_DEFAULT_FIELDS_METRIC";
   }
   else  {
       $csrb = &ora_open($lda, $GET_DEFAULT_FIELDS_ENGLISH) 
               || print "failed to open cursor $GET_DEFAULT_FIELDS_ENGLISH";
   }


#  Get Name of Product Specifications Table for input model
# -----------------------------------------------
   $pdmodel = $modelin;
   $pdmodel =~ tr/a-z/A-Z/;
   $modelprt = $pdmodel;
   &ora_bind($csra, $pdmodel);
   while (  ($pdtblname, $modelalias) = &ora_fetch($csra) )
   {
      $pdtablename = $pdtblname;
      $pdtablename =~ tr/a-z/A-Z/;
      if ( $modelalias ne '')  { $modelprt = $modelalias; }
   }
   &ora_close ($csra);

   if ($DEBUG > 0) {
      &write_comment("product data table name is $pdtablename");
      &write_comment(" input model is $pdmodel, alias is $modelalias");
   }

   @ord = ();
   @ofieldname = ();
   @ofielddisplayname = ();
   @ocolumnname = ();
   @ounits = ();

#  Get the default fields for pdtablename
#  --------------------------------------
   if ($pdtablename ne '')
   {
      &ora_bind ($csrb, $pdtablename); 
      $ii=0;
      $iordmax = 0;
      while ( ($fname, $cname, $fdname, $forder, $funits) = &ora_fetch($csrb) ) 
      {
         $ord[$ii] = $forder; 
         $iord = $ord[$ii];
         if ($iord > $iordmax)
         {
            $iordmax = $iord;
         }
         $ofieldname[$iord] = $fname;
         $ofielddisplayname[$iord] = $fdname;
         $ocolumnname[$iord] = $cname;
         $ounits[$iord] = $funits;
         if ($DEBUG > 0) {
            &write_comment("iord=$ord[$ii], $ofieldname[$iord], 
            $ofielddisplayname[$iord], $ocolumnname[$iord], $ounits[$iord]");
         }
         $ii++;
      }
      &write_comment("maximum value of iord is $iordmax");

#  Get Cursor for Correct Data Table and determine indexes for default fields
#  --------------------------------------------------------------------------

      if ($pdtablename eq 'CAES_CHILLER')                  { $GET_DATA = $CAES_CHILLER }
      if ($pdtablename eq 'CMUS_AIR_CONDENSER')            { $GET_DATA = $CMUS_AIR_CONDENSER }
      if ($pdtablename eq 'CMUS_AIR_HANDLER')              { $GET_DATA = $CMUS_AIR_HANDLER }
      if ($pdtablename eq 'CMUS_AIR_TERMINAL')             { $GET_DATA = $CMUS_AIR_TERMINAL }
      if ($pdtablename eq 'CMUS_AIR_TERMINAL_BOX')         { $GET_DATA = $CMUS_AIR_TERMINAL_BOX }
      if ($pdtablename eq 'CMUS_BOOT_DIFFUSER')            { $GET_DATA = $CMUS_BOOT_DIFFUSER }
      if ($pdtablename eq 'CMUS_CHILLER')                  { $GET_DATA = $CMUS_CHILLER }
      if ($pdtablename eq 'CMUS_DUAL_FUEL_HEAT_PUMP')      { $GET_DATA = $CMUS_DUAL_FUEL_HEAT_PUMP }
      if ($pdtablename eq 'CMUS_DUCTFREE_COOLING')         { $GET_DATA = $CMUS_DUCTFREE_COOLING }
      if ($pdtablename eq 'CMUS_DUCTFREE_HEATPUMP')        { $GET_DATA = $CMUS_DUCTFREE_HEATPUMP }
      if ($pdtablename eq 'CMUS_FANCOILS')                 { $GET_DATA = $CMUS_FANCOILS }
      if ($pdtablename eq 'CMUS_INDOOR_HORZ_PACK')         { $GET_DATA = $CMUS_INDOOR_HORZ_PACK }
      if ($pdtablename eq 'CMUS_INDOOR_VERT_PACK')         { $GET_DATA = $CMUS_INDOOR_VERT_PACK }
      if ($pdtablename eq 'CMUS_INDUCTION_UNIT')           { $GET_DATA = $CMUS_INDUCTION_UNIT }
      if ($pdtablename eq 'CMUS_LPACKROOF_EHEAT_ECOOL')    { $GET_DATA = $CMUS_LPACKROOF_EHEAT_ECOOL}
      if ($pdtablename eq 'CMUS_LPACKROOF_GHEAT_ECOOL')    { $GET_DATA = $CMUS_LPACKROOF_GHEAT_ECOOL}
      if ($pdtablename eq 'CMUS_PACKROOF_EHEAT_ECOOL')     { $GET_DATA = $CMUS_PACKROOF_EHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_PACKROOF_GHEAT_ECOOL')     { $GET_DATA = $CMUS_PACKROOF_GHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_PACK_AIR_HANDLER')         { $GET_DATA = $CMUS_PACK_AIR_HANDLER }
      if ($pdtablename eq 'CMUS_PACK_ELEC_COOL')           { $GET_DATA = $CMUS_PACK_ELEC_COOL }
      if ($pdtablename eq 'CMUS_PACK_GAS_HEAT_ELEC_COOL')  { $GET_DATA = $CMUS_PACK_GAS_HEAT_ELEC_COOL }
      if ($pdtablename eq 'CMUS_PACK_HEATING_AND_COOLING') { $GET_DATA = $CMUS_PACK_HEATING_AND_COOLING }
      if ($pdtablename eq 'CMUS_PACK_HEATPUMP')            { $GET_DATA = $CMUS_PACK_HEATPUMP }
      if ($pdtablename eq 'CMUS_PACK_ROOFTOP_HEATPUMP')    { $GET_DATA = $CMUS_PACK_ROOFTOP_HEATPUMP }
      if ($pdtablename eq 'CMUS_PACK_TERMINAL_UNIT')       { $GET_DATA = $CMUS_PACK_TERMINAL_UNIT }
      if ($pdtablename eq 'CMUS_SPLIT_SYSTEM')             { $GET_DATA = $CMUS_SPLIT_SYSTEM }
      if ($pdtablename eq 'CMUS_SPLIT_SYSTEM_HEATPUMP')    { $GET_DATA = $CMUS_SPLIT_SYSTEM_HEATPUMP }
      if ($pdtablename eq 'CMUS_UNIT_VENTILATOR')          { $GET_DATA = $CMUS_UNIT_VENTILATOR }
      if ($pdtablename eq 'CMUS_WATER_SOURCE_HEATPUMP')    { $GET_DATA = $CMUS_WATER_SOURCE_HEATPUMP }
      if ($pdtablename eq 'RAC_UNITS_HC')                  { $GET_DATA = $RAC_UNITS_HC }
      if ($pdtablename eq 'RAC_UNITS_COOL_ONLY')           { $GET_DATA = $RAC_UNITS_COOL_ONLY }
      if ($pdtablename eq 'RAC_UNITS_HEAT_COOL')           { $GET_DATA = $RAC_UNITS_HEAT_COOL }
      if ($pdtablename eq 'RAC_UNITS_HEAT_PUMP')           { $GET_DATA = $RAC_UNITS_HEAT_PUMP }

      print "<P><HR><P>\n";
      &write_comment("product data table name is $pdtablename");
      &write_comment( "query is $GET_DATA ");

      $csrc = &ora_open($lda, $GET_DATA)      || print "<!-- failed to open $GET_DATA -->";
      @fldnames  = &ora_titles($csrc);
      @flengths  = &ora_lengths($csrc);
      @ftypes    = &ora_types($csrc);

      &write_comment("total number of fields is $#fieldnames; index of ord is $#ord");

#  Get the indexes for the $#ord default fields 
#  -----------------------------------------------
      $ifld = 0;
      for ($ii=0; $ii <= $iordmax; $ii++)
      {
         if ($ofieldname[$ii] ne '')
         {
            $fieldname[$ifld]  =  $ofieldname[$ii];
            $fieldname[$ifld]  =~ tr/a-z/A-Z/;
            $columnname[$ifld] =  $ocolumnname[$ii];
            $units[$ifld]      =  $ounits[$ii];
            $index[$ifld]      =  $ii;
            &write_comment("the $ifld th fieldname is $fieldname[$ifld]");

    # Get matching fieldname
    # ----------------------
            for ($idat=0; $idat <= $#fldnames; $idat++) 
            {
               $fldnames[$idat] =~ tr/a-z/A-Z/;
               if ($fieldname[$ifld] eq $fldnames[$idat] )
               {
                  $tord[$ifld] = $idat;
                  $order[$idat] = $ifld;
                  if ($DEBUG > 0) {
                     &write_comment( "$idat, tord[$ifld] = $tord[$ifld], 
                      fieldname[$ifld]=$fieldname[$ifld],");
                     &write_comment( "fldname = $fldnames[$tord[$ifld] ]");
                  }
               }
            }
            $ifld++;
         }
      }
      $numfields = $ifld-1;

      $imsize = -1;
      print "<A NAME=\"product_data\"></A>\n";
      print "<A HREF=\"#pagetop\">(top of page)</A><BR>\n";
      print "<CENTER>\n";
      print "<FONT SIZE=4> Product Specifications for $modelprt ($unittype)</FONT><P>\n";
      print "<TABLE BORDER=3 WIDTH=70%>\n";
      print "<TR>\n";
      $imrecordid = -1;
      for ($ii=0; $ii <= $#fldnames; $ii++)
      {
          $iorder = $order[$ii];
          $fldnames[$ii] =~ tr/a-z/A-Z/;
          if ($fldnames[$ii] eq 'MODEL')
          {   $imodel = $ii; }
          if ($fldnames[$ii] eq 'MODELSIZE')
          {
              $imsize =$ii;
              print "<TD ALIGN=\"center\">Model</TD> \n";
          }
          if ($fldnames[$ii] eq 'MODEL_SIZE')
          {
              $imsize =$ii;
              print "<TD ALIGN=\"center\">Model</TD> \n";
          }
          if ($fldnames[$ii] eq 'RECORD_ID')
          {
              $imrecordid =$ii;
            #  print "<TD ALIGN=\"center\">Model</TD> \n";
          }
      }
      for ($i=0; $i <= $numfields; $i++) {
         $iorder = $order[$i];
         print "<TD ALIGN=\"center\"> $columnname[$i]";
         if($units[$i] ne '') { print "<BR>($units[$i])";}
         print "</TD>\n";
      }
      print "</TR>\n";

      $procedure = 'write_model_page2.sh?';
      &write_comment("$pdmodel, $csrc ");
      &ora_bind ($csrc, $pdmodel);
      &write_comment("after ora_bind  imsize= $imsize");
      $unitstr = 'unittype='.$unittype;
      while (  ( @pdata) = &ora_fetch($csrc)  )
      {
          print "<TR> \n";
          if ($imsize >= 0)
          {
             $mdl = $pdata[$imodel].$pdata[$imsize];
             $mdlstr = 'mdlno='.$pdata[$imodel].'&mdlsize='.$pdata[$imsize];
             $recidstr = 'recid='.$pdata[$imrecordid];
             $mdlstr = join ('&', $mdlstr, $unitstr, $recidstr);
             print "<TD ALIGN=CENTER>";
             print "<A HREF=\"$perlpath$procedure$mdlstr\">$mdl</A></TD>\n";
          }
          for ($ij =0; $ij<= $#ord; $ij++) 
          {
             if ( $pdata[$tord[$ij] ] eq "" )
             {  $pdata[$tord[$ij] ] = "NA"; }
             print " <TD ALIGN=\"center\"> $pdata[$tord[$ij] ] </TD>\n";
          }
          print "</TR>\n";
      }
      print "</TABLE><HR>\n";
      $currentdate = &formatdate;
      print "<FONT SIZE=2>$currentdate</FONT>\n";
      print "<BR><FONT SIZE=2>Specifications subject to change without notice.</FONT><BR>\n";
      print "</CENTER>\n";
      &ora_close ($csrc);
   }
   &ora_close($csrb);
}

# ******************************************
# Writes download links for model
# ******************************************
sub write_download_links
{

   local ($modelin) = @_;

   $GET_DOWNLOADS  =
                  "SELECT a.downloadmodel, a.filename, a.extension,
                          a.description, b.model
                     FROM download_objects a, 
                          download_model_association b
                    WHERE a.downloadmodel = b.downloadmodel
                      AND a.downloadable = 1
                      AND a.obsolete IS NULL
                      AND b.model = :1";

   $csra = &ora_open($lda, $GET_DOWNLOADS) || die $ora_errstr;
   &ora_bind ($csra, $modelin);
   $ii = 0;
   while ( ($dlmodelid, $dlfilename, $dlext, $dldescribe, $dlmodel) = &ora_fetch($csra) )
   {
      $dlmid[$ii] = $dlmodelid;
      $dlfname[$ii] = $dlfilename;
      $dlfext[$ii] = $dlext;
      $dldesc[$ii] = $dldesc;
      $dlm[$ii] = $dlmodel;
      if ($ii == 0)
      {
         print "<HR>\n";
         print "<B>\n";
         print "For further information about this product, the following documents\n";
         print " are available for downloading by registered users.  The registration\n";
         print " procedure and form are available through the blue 'register' button\n";
         print " in the left frame.<P>\n";
         print "</B>\n";
      }
      print "<P>$dldesc[$ii]<P>\n";
      print "$dlm[$ii] has download $dlfname[$ii].$dlext[$ii]<P>\n";
      $ii++;
   }
   &ora_close($csra);
}

# ***************************************************
# This Procedure shows default and display fields 
# ***************************************************
sub show_default_table_fields {

# for debugging; not used in production

   $csra  = &ora_open($lda, $GET_TABLE) || die $ora_errstr;
   $csrb  = &ora_open($lda, $GET_DEFAULT_FIELDS) || die $ora_errstr;
   $csrc  = &ora_open($lda, $GET_DISPLAY_FIELDS) || die $ora_errstr;

   while ( ($pdtblname ) = &ora_fetch($csra) )  
   {
      $pdtblname =~ tr/a-z/A-Z/;
      print "<BR><HR>\n";
      print "<BR>Data Table is $pdtblname;<BR> Default Fields:<P>\n";
      $pdtablename = $pdtblname;


      &ora_bind ($csrb, $pdtablename);
      $ii=0;
      while ( ($fname, $cname, $fdname, $forder) = &ora_fetch($csrb) ) 
      {
         $ii++;
         print "default order_num is $forder for $fname alias $fdname, 
            with colname $cname <BR>\n";
         $ord[$ii] = $forder; 
         $fieldname[$ii] = $fname;
         $fielddisplayname[$ii] = $fdname;
         $columnname[$ii] = $cname;
      }
      print "<CENTER><TABLE BORDER=3 WIDTH=70%>\n";
      print "<TR>\n";
      for ($i=1; $i <= $#ord; $i++) {
         print "<TD ALIGN=\"center\"> $columnname[$i] </TD>\n";
      }
      print "</TR>\n";
      print "</TABLE></CENTER>\n";

      for ($i=1; $i <= $#ord; $i++) {
         $columnname[$i] = '';
      }

      print "<P>Display Fields:<P>\n";
      &ora_bind ($csrc, $pdtablename);
      while ( ($fcname, $ccname, $fcdname, $fcorder, $funits) = &ora_fetch($csrc) ) 
      {
         print "display order_num is $fcorder for $fcname alias $fcdname, 
            with colname $ccname, units $funits <BR>\n";
      }
   }    
   &ora_close($csrb);
   &ora_close($csra);
   &ora_close($csrc);
}

# ***************************************************
# ***************************************************
sub  write_path2_unitchange_link
{

   ($model_in, $unit_type_in) = @_;

   $unit_type_in =~ tr/A-Z/a-z/;

   if ($unit_type_in eq 'english')
   {
      $unit_type_out = 'metric';
   }
   elsif ($unit_type_in eq 'metric')
   {
      $unit_type_out = 'english';
   }
   else
   {
      $unit_type_out = 'english';
   }
   $modelstr = "modelno=".$model_in;
   $unitstr = "&unittype=".$unit_type_out;
   $qstr = $modelstr.$unitstr;

   $href = $oraclepath."/CPUTT.load_com_product_info?".$qstr;
   print "<P>\n";
   print "<A TARGET=_parent HREF=\"$href\">$modelno $unit_type_out listing</A>\n";
   print "<P>\n";
}
