#!/bbn/bin/perl

# -----------------------
# copyright 1997 Carrier Corporation
# filename: export_tab_table.pl
# 
# written January 1997
# author Barbara Mihalas
# -----------------------

require 'getopts.pl';

use Oraperl;

require '/home/www.na.carrier.com_cgi-bin/cdata/pl/user_specs.pl';
require '/home/www.na.carrier.com_cgi-bin/cdata/pl/user_paths.pl';

  $diagnosticlog = "logs/REGDUMP1.log";

  open (LOGFILE, ">>$diagnosticlog");
   # || print "failed to open logfile $diagnosticlog \n";

# ==========================================================
# ================= oraperl setup ==========================
  print LOGFILE "query string is $ENV{'QUERY_STRING'}<BR>\n";
  print LOGFILE "oracle_home is $ENV{'ORACLE_HOME'}<BR>\n";
  print LOGFILE "PATH is $ENV{'PATH'}<BR>\n";
# ------------------------------------------------------------
# -----------------
  $ora_debug = shift if $ARGV[0] =~ /^-#/;
# ----------------
# login to the database
# ---------------------
  $lda = &ora_login('WG73', $user, $pword)	|| die $ora_errstr;
# ==============  end of oraperl setup =======================
# ============================================================
# ==============  define cursors =============================

  $SELECT_USER_REG =
                 "SELECT 
                  record_id,        username,       user_pw,           user_fname, 
                  user_lname,       user_title,     user_reg_status,   user_permissions, 
                  company,          address1,       address2,          city, 
                  state,            region,         zip_code5,         zip_code4, 
                  postal_code,      country,        company_URL,       user_phone, 
                  user_fax,         user_email,     contact_id,        contact_name, 
                  contact_company,  contact_phone,  contact_fax,       contact_email, 
                  contact_location, email_ok,       ptac_req,          ltcom_req,
                  res_req,          com_req,        reg_date,          last_updated, 
                  user_phone_num,   reg_notes,      user_phone_ext,    user_phone_ext1,
                  reg_group,        crr_id
                  FROM user_reg
                  ORDER BY record_id";
                # WHERE record_id > :1"; 


# ==============  end of cursors =============================

# ============================================================
# =================== body of program ========================

  &html_header;

# Read input buffer
# read( STDIN, $buffer, $ENV{'CONTENT_LENGTH'} );

# Optional printout
# print "<BR>BUFFER is $buffer\n";
# print "\n<br>CONTENT_LENGTH = $ENV{'CONTENT_LENGTH'}<br>\n";
# print "<p><hr>";

# Parse input buffer
  &parse_dummy;
# &parse;

  &write_tabfile;

# &email_tabfile;

  &html_footer;

  close(LOGFILE);
# ==================end  body of program =====================
# ============================================================

# ================= oraperl cleanup ========================
# log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================


# =============== start of subroutines =======================

# *********************************************
# This Procedure Parses the Input from any Form
# *********************************************
sub parse{
   local($x, $y);
   local(@temp);
   local(%fields);
   @temp = split("&", $buffer);

   for ($i = 0; $i <= $#temp; $i++) 
   {
       ($x, $y) = ($temp[$i] =~ /(\S*)=(\S*)/);
       $fields{$x} = $y;
       $value[$i]=$y;
       $value[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $value[$i]=~ tr/\+/ /;
       $name[$i] = $x;
       $name[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $name[$i]=~ tr/\+/ /;
       print "<FONT SIZE=4>$i . $name[$i] . $value[$i]</FONT> <br>\n";

       if ($name[$i] eq "filename") {   $outfile = $value[$i];  }
       if ($name[$i] eq "recordid") {   $recid = $value[$i];  }
       if ($name[$i] eq "email") {   $emailaddress = $value[$i];  }
   }
   $fields = $i-1;
   $numfields = $fields+1;
   print " output filename is $outfile <P>\n";
   print " last record_id is $recid <P>\n";
   print " email address is $emailaddress <P> \n";
}

# *********************************************
# This Procedure Mocks up the Parses the Input from any Form
# *********************************************
sub parse_dummy
{
    $outfile = "user_reg_03dec98.tab";
  # $outfile = 'BSS_autoreg_30nov97.tab';
    $recid  = 0;
    $email  = "bwm@npac.syr.edu";
    $numfields = 4;
}

# *********************************************
# Read table and write out as tabfile
# *********************************************
sub write_tabfile
{
   local ($i, $numcols, @reg_entry);

 # $outdir = '/oradata/disk4/carrier/bwm-admin/';
   
   $csra  = &ora_open($lda, $SELECT_USER_REG) 
                     || print "failed to open $SELECT_USER_REG \n";

   &ora_bind($csra, $recid);

   @fldnames  = &ora_titles($csra);
   @flengths  = &ora_lengths($csra);
   @ftypes    = &ora_types($csra);
   if ($outfile eq "")
   {  $outfile = 'user_reg_3dec98.tab'; }
   else
   {  $outfile =~ s/ /_/g;   }
 # $outfile = $outdir.$outfile;

   print " Output filename is $outfile <P>\n";
      
   open (OUTFILE, ">$outfile");
      #  || print LOGFILE "failed to open output tabfile $outfile for writing\n";;

   print LOGFILE "opened tabfile $outfile for writing\n";

   $numcols = $#fldnames;
   for ( $i = 0; $i <= $numcols; $i++)
   {
      print OUTFILE "$fldnames[$i]	";
      print "$fldnames[$i]	";
   }
   print OUTFILE "\n";
   print "\n";
   

#  while ($record_id,       $username,      $user_pw,          $user_fname, 
#         $user_lname,      $user_title,    $user_reg_status,  $user_permissions, 
#         $company,         $address1,      $address2,         $city, 
#         $state,           $region,        $zip_code5,        $zip_code4, 
#         $postal_code,     $country,       $company_URL,      $user_phone, 
#         $user_fax,        $user_email,    $contact_id,       $contact_name, 
#         $contact_company, $contact_phone, $contact_fax,      $contact_email, 
#         $contact_location,$email_ok,      $ptac_req,         $ltcom_req,
#         $res_req,         $com_req,       $reg_date,         $last_updated, 
#         $user_phone_num,  $reg_notes,     $user_phone_ext,   $user_phone_ext1)

   while ( (@reg_entry) = &ora_fetch($csra) )
   {
       $numcols = $#reg_entry;
       for ( $i = 0; $i <= $numcols; $i++)
       {
          $reg_entry[$i] =~ s/\r\n//g;
          $reg_entry[$i] =~ s/\n//g;
          print OUTFILE "$reg_entry[$i]	";
        # print "$reg_entry[$i]	";
       }
       print OUTFILE "\n";
     # print "\n";
   }
   close (OUTFILE);
   &ora_close($csra);
}

# ******************************************
# Writes text as HTML comment
# ******************************************
sub write_comment 
{
   local ($text) = @_; 
   print "<!-- $text -->\n";
}

# ******************************************
# This Procedure writes the HTML header
# ******************************************
sub html_header 
{
 print "Content-type:text/html\n\n";
 print "<HTML>\n";
 print +"<HEAD>\n";
 print +"<TITLE>Placeholder for document title</TITLE>\n";
 print +"</HEAD>\n";
 print "<BODY BGCOLOR=\#FFFFFF >\n";
}

# ******************************************
# This Procedure writes the HTML footer
# ******************************************
sub html_footer 
{
  print "</BODY>";
  print "</HTML>";
}

