#!/usr/local/bin/oraperl
# -----------------------
# filename:
# write_com_types_cd.pl
# written April 1997
# author Barbara Mihalas
# -----------------------

require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/user_specs.pl';
require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/user_paths.pl';

# ==============  define cursors =============================
require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/download_queries.pl';
# Elec lit (64); Elec catalog (51); CAD templates (37)
# ==============  end of cursors =============================

# ===== oraperl setup ========
  &oracle_login;
# ===== oraperl setup ========

# ==============  end of oraperl setup =======================
# ============================================================


  $GET_GENERALTYPE   =
                 "SELECT DISTINCT generaltype
                    FROM commercial_products
                   WHERE obsolete = 0
                   ORDER BY generaltype";

  $GET_SPECIFICTYPE  =
                  "SELECT DISTINCT specifictype
                     FROM commercial_products
                    WHERE generaltype = :1
                      AND obsolete = 0
                    ORDER BY specifictype";

  $GET_GENTYPEALIAS  =
                 "SELECT gtalias
                    FROM gentypealias
                   WHERE generaltype = :1";

  $GET_SPECTYPEALIAS =
                 "SELECT stalias
                    FROM spectypealias
                   WHERE specifictype = :1";

# ==============  end of cursors =============================

# ============================================================
# =================== body of program ========================

  $csrgen = &ora_open($lda, $GET_GENERALTYPE)    || die $ora_errstr;
  $csrspc = &ora_open($lda, $GET_SPECIFICTYPE)   || die $ora_errstr;
  $csrgt  = &ora_open($lda, $GET_GENTYPEALIAS)   || die $ora_errstr;
  $csrst  = &ora_open($lda, $GET_SPECTYPEALIAS)  || die $ora_errstr;

  $basename = "CPLIST";
  $subdirectory = $basename;
  $directory = $pdpdirpath.$subdirectory;

# artifacts -- do not use on live site -------
# mkdir ($directory, 0777);
# print CPTLOG "basename is $basename, directory is $directory \n";
# $logfilename = $basename.".log";
# $logfile = "logs/".$logfilename;
# &write_indexpage ($directory, $basename);
# &write_cframepage($directory, $basename);
# artifacts -- do not use ------------
      
  &write_dframepage($directory, $basename);

  &ora_close($csrgen);
  &ora_close($csrspc);
  &ora_close($csrgt);
  &ora_close($csrst);

# ==================end  body of program =====================
# ============================================================

# ================= oraperl cleanup ========================
# log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================


# =============== start of subroutines =======================

# ********************************************
# Writes the index static page for input model
# ********************************************

sub write_indexpage
{
   local ($subdir, $namestr ) = @_;

   $indexfile = $subdir."/index.html";
   open(INDEXFILE, ">$indexfile") 
     || print LOGFILE "can't open filename $indexfile for writing<BR>\n";

   $cframefilename = $namestr."_c.html";
   $dframefilename = $namestr."_d.html";

   select (INDEXFILE); 
   &html_header_index;

   print "\n\n";
   print "<FRAMESET COLS=\"162,*\">\n";
   print "<FRAMESET ROWS=\"66,*\">\n\n";

   print "<FRAME SRC=\"../com_ed1/com_eda1_plain.html\" 
           NAME=\"logo\" SCROLLING=\"no\" \n";
   print "MARGINWIDTH=1 MARGINHEIGHT=1 NORESIZE>\n\n";
   print "<FRAME SRC=\"../com_ed1/com_edc1_plain.html\" 
           NAME=\"contentNav\" SCROLLING=\"auto\" \n";
   print "MARGINWIDTH=8 MARGINHEIGHT=8 NORESIZE>\n";
   print "</FRAMESET>\n\n";

   print "<FRAMESET ROWS=\"66,*\">\n";
   print "<FRAME SRC=\"../com_ed1/com_edb1_plain.html\" 
           NAME=\"header\" SCROLLING=\"no\" \n";
   print "MARGINWIDTH=16 MARGINHEIGHT=1 NORESIZE> \n\n";
   print "<FRAME SRC=\"$dframefilename\" NAME=\"bodyText\" 
           SCROLLING=\"vert\"  \n";
   print "MARGINWIDTH=12 MARGINHEIGHT=12 NORESIZE> \n\n";
   print "</FRAMESET> \n\n";
   print "</FRAMESET> \n\n";

   &html_footer; 
   select;
   close (INDEXFILE);
}

# *************************************************************
# Writes the c frame static page for input gentype and spectype
# *************************************************************

sub write_cframepage
{
   local ($subdir, $namestr ) = @_;

   $cframefilename = $namestr."_c.html";
   $cframefile = $subdir."/$cframefilename";
   open(CFRAMEFILE, ">$cframefile") 
     || print LOGFILE "can't open filename $cframefile for writing<BR>\n";

   select (CFRAMEFILE); 
   &html_header_file;

   &nav_upto_carrier_homepage;
   &nav_upto_comfort_atwork;
   &hotlink_commercial_whatsnew;
   &hotlink_commercial_qa;
   &hotlink_commercial_locator;

#  &list_com_model_fields($modelin);

#  &list_electronic_documents($modelin);

   print "<BR><HR ALIGN=center WIDTH=100><BR> \n";

#  &list_models($modelin);

   print "<BR><HR ALIGN=center WIDTH=100><BR> \n";

   &com_resource_buttons;

   print "<BR><HR ALIGN=center WIDTH=100><BR> \n";

   &hotlink_copyright;


   &html_footer;
   close (CFRAMEFILE);
   select;
}

# ******************************************
# write the frameD page
# ******************************************
sub write_dframepage
{
   local ($subdir, $namestr ) = @_;

   &html_header_file;

   print "<!-- 11/8/97 revision --><BR>\n";

   &caw_frameD_back_header;

   print "<P><P> \n";

   $pfilename = 'ptypes.html';
   $ptypefile = $textpath.$pfilename;
   open (PTYPES, "<$ptypefile")
        || print LOGFILE "failed to open $ptypefile for reading\n";
   while (<PTYPES>)
   {
      chop;
      print "$_\n";
   }
   close PTYPES;

   print "<TABLE BORDER=0>\n";
   while ( ($generaltype) = &ora_fetch($csrgen) )
   {
      
      print "<TR><TD>\n";
      print "<A NAME=\"$generaltype\"></A>\n";
      $uppergentype = $generaltype;
      $uppergentype =~ tr/a-z/A-Z/;
      print "<P><B> $generaltype </B><BR>\n";
      print "<UL>\n";
      $hgen = $generaltype;
      $hgen =~ s/ /+/g;
      $hgen =~ s/-/%2D/g;
 
      &ora_bind ( $csrspc, $generaltype); 
      while ( ($specifictype) = &ora_fetch($csrspc) ) 
      {

         $hsp = $specifictype;
         $hsp =~ s/ /+/g;
         $hsp =~ s/-/%2D/g;
         $spectype = join('$', $hgen, $hsp);
 
      # write the link for the specific type
         print "<A HREF=\"$oraclepath/CPUT.llm?spec_type=$spectype\"  
           TARGET=\"_parent\" > $specifictype </A> <BR>\n";
      }
      print "</UL>\n";
      print "</TD>\n";
      print "<TD VALIGN=\"top\"><A HREF=\"#pagetop\">\n";
      print "<FONT SIZE=2>up to product types</FONT></A>\n";
      print "</TD></TR>\n";
 
   }
   print "</TABLE>\n";

}
