#!/usr/local/bin/perl54

# -----------------------
# filename:
# write_path1_fieldpage.pl
# revised oct 1997
# author Barbara Mihalas
# -----------------------

$DEBUG = 0;

require 'getopts.pl';

use Oraperl;

require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/user_specs.pl';
require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/user_paths.pl';

$unittype = 'English';

# ===== HTML setup ======
  &html_header('Path 1 product page with specification table');
# ===== HTML setup ======

  print "<!-- 11/8/97 revision --><BR>\n";

# ===== oraperl setup ========
  &oracle_login;
# ===== oraperl setup ========

# ==========================================================

# ==============  define cursors =============================
  $GET_TABLE   = "SELECT distinct datatablename 
                    FROM commercial_products 
                   WHERE obsolete = 0
                   ORDER BY datatablename";
 
  $GET_TABLENAME   =
                 "SELECT datatablename, modelalias
                    FROM commercial_products 
                   WHERE model = :1";
 
  $GET_DEFAULT_FIELDS = 
                 "SELECT fieldname, columncaption, fielddisplayname,
                         defaultfieldorder, englishunits
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND defaultfield=1
                     AND upper(tablename) = :1";
 
  $GET_DISPLAY_FIELDS = 
                 "SELECT fieldname, columncaption, fielddisplayname,
                         displayorder, englishunits
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND displayfield=1
                     AND upper(tablename) = :1";

  $GET_TEXT_FILENAME  =
                 "SELECT a.filename, a.extension, b.pagetype
                    FROM text_objects a, text_model_association b
                   WHERE upper(b.model) = :1
                     AND lower(b.usage) = 'product description'
                     AND a.textid = b.textid";

  $GET_GRAPHICS       =
                 "SELECT a.title, a.caption, a.filename, a.extension,
                         b.pagetype, b.usage
                    FROM graphic_objects a, 
                         graphic_model_association b
                   WHERE upper(b.model) = :1
                     AND lower(b.pagetype) LIKE 'product page%'
                     AND a.graphicid = b.graphicid";

  $CHECK_TEXT         =
                 "SELECT count(*) 
                    FROM text_model_association
                   WHERE upper(model) = :1
                     AND lower(usage) = :2";
  

# ==============  end of cursors =============================

#========== Associative arrays for path 1 tables =============

%bttext = 
  ('bt01',  'Colleges/<BR>Universities',
   'bt02',  'Elementary/<BR>High Schools',
   'bt03',  'Hospitals',
   'bt04',  'Extended Care<BR> Facilities',
   'bt05',  'Hotels',
   'bt06',  'Motels',
   'bt07',  'Manufacturing<BR> General Purpose/<BR>Office',
   'bt08',  'Manufacturing<BR> Industrial<BR> or Process',
   'bt09',  'High Rise<BR> Offices',
   'bt10',  'Low Rise<BR> Offices',
   'bt11',  'Large<BR> Retail Store',
   'bt12',  'Small<BR> Retail Store',
   'bt13',  'Apartments',
   'bt14',  'Warehouses');

%sctext = 
  ('sc01',  'VAV FPMB with<BR> Central Station<BR> Air Handler with<BR> Chilled Water',
   'sc02',  'VAV Terminal with<BR> Central Station<BR> Air Handler and<BR> Chilled Water',
   'sc03',  'VAV Box<BR> Boot with<BR> Central Station<BR> Air-Handler and<BR> Chilled Water',
   'sc04',  'Chilled Water<BR> Multizone',
   'sc05',  'VAV Reheat<BR> Box Boot with<BR> Central Station<BR> Air Handler and<BR> Chilled Water',
   'sc06',  'Double Duct<BR> (Dual Duct) with<BR> Central Air-Handler<BR> and Chilled Water',
   'sc07',  'Induction<BR> Unit with<BR> Central Station<BR> Air Handler and<BR> Chilled Water',
   'sc08',  'Central Station<BR> Air-Handler with<BR> Chilled Water (CAV)',
   'sc09',  'Chilled Water<BR> Fan Coil<BR> System',
   'sc10',  'VAV FPMB with<BR> Packaged<BR> Equipment',
   'sc11',  'VAV Terminal<BR> with Packaged<BR> Equipment',
   'sc12',  'VAV Box Boot<BR> with Packaged<BR> Equipment',
   'sc13',  'Packaged<BR> Multizone<BR> System',
   'sc14',  'VVT System<BR> (VAV Bypass)<BR> with Packaged<BR> Equipment',
   'sc15',  'Direct Expansion<BR> (DX) Split System',
   'sc16',  'Packaged<BR> Equipment<BR> (CAV)',
   'sc17',  'PTAC<BR> (Packaged Terminal<BR> Air-Conditioner)',
   'sc18',  'WSHP<BR> (Water Source<BR> Heat Pump)');

%cttext = 
  ('ct01',  'Fan-Powered<BR> Mixing Boxes',
   'ct02',  'Central-Station<BR> Air-Handler(s)',
   'ct03',  'Water<BR> Chiller(s)',
   'ct04',  'Controls',
   'ct05',  'VAV Terminals',
   'ct06',  'Linear Boot<BR>Diffusers',
   'ct07',  'VAV<BR> Damper Boxes',
   'ct08',  'Central-Station<BR> Air-Handler(s) with<BR> multizone dampers',
   'ct09',  'Boot<BR> Diffusers',
   'ct10',  'VAV<BR> Damper Boxes with<BR> Reheat Coils',
   'ct11',  'Dual-Duct<BR> Mixing Box',
   'ct12',  'Induction<BR> Units',
   'ct13',  'Fan Coil<BR> Units',
   'ct14',  'Packaged<BR> Unit(s)',
   'ct15',  'Packaged<BR> Multizone<BR> Unit(s)',
   'ct16',  'Bypass<BR> Dampers',
   'ct17',  'Condensing<BR> Unit(s)',
   'ct18',  'Fan-Coil<BR> Air Handler(s)',
   'ct19',  'Refrigerant<BR> Piping and<BR> Accessories ',
   'ct20',  'Packaged<BR> Terminal<BR> Air Conditioner(s)',
   'ct21',  'Integral<BR> Wall Sleeve',
   'ct22',  'Water Source<BR> Heat Pump<BR> Units',
   'ct23',  'Water Piping<BR> and<BR> Accessories');

#====== END:Associative arrays for path 1 tables =============

#============== Graphic Data for Path 1 Links ================

$bldgtypegif  = 'com_media/building_type_btn.gif';
$syschoicegif = 'com_media/system_choice_btn.gif';
$syscomptgif  = 'com_media/system_component_btn.gif';
$compttypegif = 'com_media/component_type_btn.gif';
$compmodelgif = 'com_media/component_model_btn.gif';

$btimg = $docpath.$bldgtypegif;
$scimg = $docpath.$syschoicegif;
$sctimg = $docpath.$syscomptgif;
$ctimg = $docpath.$compttypegif;
$cmimg = $docpath.$compmodelgif;

&write_comment("building type image path/gif is $btimg");

# ============================================================
# =================== body of program ========================

  &get_query;

  $modelno = $value[0];
  $path1string = $value[1];

 #$unittype set to 'English' at beginning of program

  &write_comment("input path 1 string is $path1string");

  &parse_path1string($path1string);

  &write_modelpage ($modelno, $unittype);

# ==================end  body of program =====================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ================= oraperl cleanup ========================
# log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================

# =============== start of subroutines =======================
# *********************************************
# Parse the path 1 input string
# *********************************************
sub parse_path1string
{
   local($pstring) = @_;
   $pstring = substr($pstring,4);
   &write_comment("substr of path1string is $pstring");
   @parr = split(/_/, $pstring);
   &write_comment("$pstring splits into $parr[0], $parr[1], $parr[2]");
}

# *********************************************
# Create and write the path 1 backlinks
# *********************************************
sub path1_links
{
   &write_comment("parr is $parr[0], $parr[1], $parr[2]");
   $btlink = $docpath.'com_sh2/com_shd2.html';
   print "<TABLE CELLSPACING=0 CELLPADDING=0>\n";
   print "<TR><TD>\n";
   print "<A TARGET=\"bodyText\" HREF=\"$btlink\">\n";
   print "<IMG SRC=\"$btimg\" ALIGN=\"center\" WIDTH=81 HEIGHT=35  BORDER=0></A>\n";
   print "</TD><TD>\n";

   $btdir = 'com_'.$parr[0];
   $btfile = $btdir.'.html';
   $btpath = $docpath.$btdir;
      &write_comment("bldg type directory is $btdir, file is $btfile");
      &write_comment("docpath is $docpath ");
   $sclink = join('/', $btpath, $btfile);
      &write_comment("sclink is $sclink");
   print "<A TARGET=\"bodyText\" HREF=\"$sclink\">\n";
   print "<IMG SRC=\"$scimg\" ALIGN=\"center\" WIDTH=81 HEIGHT=35  BORDER=0></A>\n";

   print "</TD><TD>\n";
   $scfile = join('_', $btdir, $parr[1]);
   $scfile = $scfile.'.html';
   $sctlink = join('/', $btpath, $scfile);
   print "<A TARGET=\"bodyText\" HREF=\"$sctlink\">\n";
   print "<IMG SRC=\"$sctimg\" ALIGN=\"center\" WIDTH=81 HEIGHT=35  BORDER=0></A>\n";

   print "</TD><TD>\n";
   $sctfile = join('_', $btdir, $parr[1], $parr[2]);
   $sctfile = $sctfile.'.html';
   $ctlink = join('/', $btpath, $sctfile);
   print "<A TARGET=\"bodyText\" HREF=\"$ctlink\">\n";
   print "<IMG SRC=\"$ctimg\" ALIGN=\"center\" WIDTH=81 HEIGHT=35  BORDER=0></A>\n";

   print "</TD><TD>\n";
   print "<IMG SRC=\"$cmimg\" ALIGN=\"center\" WIDTH=81 HEIGHT=35  BORDER=0></A>\n";
   print "</TD></TR>\n";
   print "<TR><TD ALIGN=CENTER>\n";
   print "<FONT SIZE=2><B>$bttext{$parr[0]}</FONT></B>\n";
   print "</TD><TD ALIGN=CENTER>\n";
   print "<FONT SIZE=2><B>$sctext{$parr[1]}</FONT></B>\n";
   print "</TD><TD ALIGN=CENTER>\n";
   print "<FONT SIZE=2><B>$cttext{$parr[2]}</FONT></B>\n";
   print "</TD><TD ALIGN=CENTER>\n";
   &get_specific_type($modelno);
   
   print "<FONT SIZE=2><B>$specifictype</FONT></B>\n";
   print "</TD><TD ALIGN=CENTER>\n";
   $YAHgif = 'com_media/you_are_here.gif';
   $YAHimg = $docpath.$YAHgif;
   print "<IMG SRC = \"$YAHimg\" ALIGN=\"LEFT\" WIDTH=57 HEIGHT=20 BORDER=0>\n";
   print "</TD></TR>\n";
   print "</TABLE>\n";
}

# ***************************************************
# Get the specific type for an input model
# ***************************************************
sub get_specific_type
{
   local($modelin) = @_;

   $modeluc = $modelin;
   $modeluc =~ tr/a-z/A-Z/;

   $GET_SPECIFIC_TYPE = 
                  "SELECT specifictype 
                     FROM commercial_products
                    WHERE upper(model) = :1";

   $csrspec = &ora_open ($lda, $GET_SPECIFIC_TYPE) 
                  || print "failed to open $GET_SPECIFIC_TYPE\n";

   &ora_bind($csrspec, $modeluc);
   ($specifictype) = &ora_fetch($csrspec);
   &ora_close($csrspec);
}

# ***************************************************
# This Procedure shows default and display fields 
# ***************************************************
sub show_default_table_fields {

   $csra  = &ora_open($lda, $GET_TABLE) || die $ora_errstr;
   $csrb  = &ora_open($lda, $GET_DEFAULT_FIELDS) || die $ora_errstr;
   $csrc  = &ora_open($lda, $GET_DISPLAY_FIELDS) || die $ora_errstr;

   while ( ($pdtblname ) = &ora_fetch($csra) )  
   {
      $pdtblname =~ tr/a-z/A-Z/;
      print "<BR><HR>\n";
      print "<BR>Data Table is $pdtblname;<BR> Default Fields:<P>\n";
      $pdtablename = $pdtblname;


      &ora_bind ($csrb, $pdtablename);
      $ii=0;
      while ( ($fname, $cname, $fdname, $forder) = &ora_fetch($csrb) ) 
      {
         $ii++;
         print "default order_num is $forder for $fname alias $fdname, 
            with colname $cname <BR>\n";
         $ord[$ii] = $forder; 
         $fieldname[$ii] = $fname;
         $fielddisplayname[$ii] = $fdname;
         $columnname[$ii] = $cname;
      }
      print "<CENTER><TABLE BORDER=3 WIDTH=70%>\n";
      print "<TR>\n";
      for ($i=1; $i <= $#ord; $i++) {
         print "<TD ALIGN=\"center\"> $columnname[$i] </TD>\n";
      }
      print "</TR>\n";
      print "</TABLE></CENTER>\n";

      for ($i=1; $i <= $#ord; $i++) {
         $columnname[$i] = '';
      }

      print "<P>Display Fields:<P>\n";
      &ora_bind ($csrc, $pdtablename);
      while ( ($fcname, $ccname, $fcdname, $fcorder, $funits) = &ora_fetch($csrc) ) 
      {
         print "display order_num is $fcorder for $fcname alias $fcdname, 
            with colname $ccname, units $funits <BR>\n";
      }
   }    
   &ora_close($csrb);
   &ora_close($csra);
   &ora_close($csrc);
}

# ******************************************
# Writes the product page for input model
# ******************************************
sub write_modelpage
{
   local ($modelin, $unittype) = @_;

   &caw_frameD_back_header;
   print "<P>\n";

   &path1_links;

   print "<BR>\n";

 # Check for product data
 # ----------------------
   $csrtab = &ora_open($lda, $GET_TABLENAME) || die $ora_errstr;
   &ora_bind ($csrtab, $modelin);
   ($tablename, $modelalias) = &ora_fetch($csrtab);

   $modelprt = $modelin;
   if ( $modelalias ne '')  { $modelprt = $modelalias; }

   if ($tablename ne '') 
   {
      print "<A HREF=\"#product_data\">";
      print "<I>(down to product specifications)</I></A><BR>\n";
   }
   &ora_close($csrtab);

   &write_comment(" input model is $modelin\n");

   $csra = &ora_open($lda, $GET_TEXT_FILENAME) || die $ora_errstr;
   $csrb = &ora_open($lda, $GET_GRAPHICS)      || die $ora_errstr;
   $csrc = &ora_open($lda, $CHECK_TEXT)        || die $ora_errstr;

   $uppermodel = $modelin;
   $uppermodel =~ tr/a-z/A-Z/;
   &ora_bind ($csra, $uppermodel);
   &ora_bind ($csrb, $uppermodel);
   &ora_bind ($csrc, $uppermodel, 'product description');

   print "<CENTER><FONT SIZE=5>\n";
   print "<P>Product Information for $modelprt <BR>\n";
   print "</FONT></CENTER>\n";

   while ( ($photo_title, $photo_caption, $photo_filename, $photo_extension,
           $photo_pagetype, $photo_usage) = &ora_fetch($csrb) )
   {
      $photo_extension =~ tr/A-Z/a-z/;
      if ($photo_extension eq 'bmp') { $photo_extension = 'jpg'; }
      $photo_filename =~ tr/a-z/A-Z/;
      $photo_filename_uc = $photo_filename;
      $photo_filename =~ tr/A-Z/a-z/;
      $photo_filename_lc = $photo_filename;

      $photo_extension_lc = '.'.$photo_extension;
      $photo_extension_uc = '.'.$photo_extension;
      $photo_extension_lc =~ tr/A-Z/a-z/; 
      $photo_extension_uc =~ tr/A-Z/a-z/; 
      
      $photo_filename_uc = $photo_filename_uc.$photo_extension_uc;
      $photo_filename_lc = $photo_filename_lc.$photo_extension_lc;
      $IMG_SRC = $docpath."com_media/".$photo_filename_lc;

      $IMG_ALT = $docpath."com_media/".$photo_filename_uc;

      print "<CENTER>\n";
      print "<IMG SRC =\"$IMG_SRC\"  ALT=\"$IMG_ALT\" ALIGN=CENTER>\n";
      print "</CENTER>\n";
   }
   &ora_close ($csrb);
   print "<P><P>\n";

   while ( ($textno) = &ora_fetch ($csrc) )
   {
       $ntext = $textno;
       &write_comment("number of text files is $ntext\n");
   }
   &ora_close ($csrc);

   if ($ntext > 0 )
   {
      while (  ($text_filename, $text_extension, $text_pagetype)
         = &ora_fetch($csra) )
      {
         $text_filename =~ s/\s/_/g;
         $text_filename =~ s/-/_/g;
         $text_filename = $text_filename.".html";
         $text_location = $textpath.$text_filename;
         $text1 = "Unix text filename is [ $text_filename ]\n";
         &write_comment( $text1 );
         $text_link = $text_location;
         open(TEXTFILE, $text_link) || print "<BR>\n";
         while (<TEXTFILE>)
         {
            chop;
            print "$_\n";
         } 
         close TEXTFILE;
      }
      &ora_close($csra);
   }

#  &write_download_links ($modelin);

   &write_default_table ($modelin, 'english');   

   &write_default_table ($modelin, 'metric');   

   &frameD_topofpage;
}

# ******************************************
# Writes download links for model
# ******************************************
sub write_download_links
{

   local ($modelin) = @_;

   $GET_DOWNLOADS  =
                  "SELECT a.downloadmodel, a.filename, a.extension,
                          a.description, b.model
                     FROM download_objects a, 
                          download_model_association b
                    WHERE a.downloadmodel = b.downloadmodel
                      AND b.model = :1
                      AND a.obsolete IS NULL";

   $csra = &ora_open($lda, $GET_DOWNLOADS) || die $ora_errstr;
   &ora_bind ($csra, $modelin);
   $ii = 0;
   while ( ($dlmodelid, $dlfilename, $dlext, $dldescribe, $dlmodel) = &ora_fetch($csra) )
   {
      $dlmid[$ii] = $dlmodelid;
      $dlfname[$ii] = $dlfilename;
      $dlfext[$ii] = $dlext;
      $dldesc[$ii] = $dldesc;
      $dlm[$ii] = $dlmodel;
      if ($ii == 0)
      {
         print "<HR>\n";
         print "<B>\n";
         print "For further information about this product, the following documents\n";
         print " are available for downloading by registered users.  The registration\n";
         print " procedure and form are available through the blue 'register' button\n";
         print " in the left frame.<P>\n";
         print "</B>\n";
      }
      print "<P>$dldesc[$ii]<P>\n";
      print "$dlm[$ii] has download $dlfname[$ii].$dlext[$ii]<P>\n";
      $ii++;
   }
   &ora_close($csra);
}
